# Generalized assignment

set JOBS := 1..6;
set MACHINES := 1..2;
param a {JOBS,MACHINES};
param b {MACHINES};
param c {JOBS,MACHINES};

##### Modello del problema master
# DATI
param nCOL {MACHINES} integer >=0, default 0;
set COLUMNS {m in MACHINES} := 1..nCOL[m];
param Cost {m in MACHINES,COLUMNS[m]};
param y {JOBS,m in MACHINES,COLUMNS[m]};

# VARIABILI
var theta {m in MACHINES,COLUMNS[m]} binary;

# OBIETTIVO
minimize z: sum {m in MACHINES, j in COLUMNS[m]} Cost[m,j] * theta[m,j];

# VINCOLI
# Vincoli di assegnamento (copertura)
subject to Assign {i in JOBS}:
  sum {m in MACHINES, j in COLUMNS[m]} y[i,m,j] * theta[m,j] >= 1;
  
# Vincoli di convessit
subject to Convexity {m in MACHINES}:
  sum {j in COLUMNS[m]} theta[m,j] <= 1;
  
#
##### Modello del pricing
# DATI
param lambda {JOBS};	# Variabili duali vincoli Assign
param mu {MACHINES};	# Variabili duali vincoli Convexity

# VARIABILI
var x {JOBS,MACHINES} binary;

# OBIETTIVO
minimize Reduced_Cost: sum {m in MACHINES}
  ( sum {i in JOBS} (c[i,m] - lambda[i]) * x[i,m] - mu[m] );
  
# VINCOLI
subject to Capacity {m in MACHINES}:
  sum {i in JOBS} a[i,m] * x[i,m] <= b[m];

end;
